package ru.landgrafhomyak.db.sql_skeleton_0.api.misc

import kotlin.jvm.JvmName
import ru.landgrafhomyak.db.sql_skeleton_0.api.raw.DialectResolver

public interface DatabaseType<RUNTIME_TYPE : Any?> {
	public val nullable: DatabaseType<RUNTIME_TYPE?>

	@Suppress("INAPPLICABLE_JVM_NAME")
	@get:JvmName("getName")
	public val name: String


	public interface DefaultTypes {
		@Suppress("INAPPLICABLE_JVM_NAME", "PropertyName")
		@get:JvmName("BOOLEAN")
		public val BOOLEAN: DatabaseType<Boolean>

		@OptIn(ExperimentalUnsignedTypes::class)
		@Suppress("INAPPLICABLE_JVM_NAME", "PropertyName")
		@get:JvmName("BINARY_DATA")
		public val BINARY_DATA: DatabaseType<UByteArray>

		@OptIn(ExperimentalUnsignedTypes::class)
		public fun BINARY_DATA(size: UInt, isFixedSize: Boolean): DatabaseType<UByteArray>

		public fun <RUNTIME_TYPE> custom(resolver: DialectResolver.Type<RUNTIME_TYPE>): DatabaseType<RUNTIME_TYPE>
	}
}
